#!/usr/bin/perl

# $Id: updatevirex.pl,v 1.7 2004/02/06 18:37:58 seiz Exp $

# The location of the Virex vscan command-line utility
$virexdir="/usr/local/vscanx";

# Where to look for the McAfee DAT files
#$serverurl="http://www.mcafeeb2b.com/naicommon/download/dats/mcafee_4x.asp";
#$serverurl="http://www.networkassociates.com/us/downloads/updates/dat.asp";
$serverurl="ftp://ftp.nai.com/pub/antivirus/datfiles/4.x/";

# People to contact when an update is made.
$mail="postmaster\@localhost";
# FROM Address for the Notification email
$frommail="postmaster\@localhost";
# Get the Hostname via the Systems hostname comand to include in the email subjext later on
$hostn=`hostname`; chomp($hostn);

##############
# The rest is none of your business.
##########
my $daturl="";
my $test = $1;

$version=`$virexdir/vscanx --version`;
$version=~/data\s+file[^0-9]+([0-9]+)/is;
$version=$1;

$getdat=`/usr/bin/curl -s -l --stderr - "$serverurl"`;

my $curlreturn = $getdat;
if ($getdat=~/(.*)(dat\-[^\"]+tar)/si){
	$daturl=$2;
}

#print "Daturl: $daturl\n";

if ( $daturl eq "" )
{
	# Couldn't get Datfile
	# Did McAfee change their URL again?
	
	$date=`date`;
	chomp($date);
	open EMAIL, "| mail -s 'DAT Update on $hostn failed' -f $frommail $mail";
		print EMAIL "DAT Update: $date\n\n";
		print EMAIL "ERROR! $curlreturn\n";
		print EMAIL "Check the URL <$serverurl> in a browser.\n";
	close (EMAIL);
}
else
{
	
#	print "Dat is at: $daturl\n";
	
	$datfile=$daturl;
	$datfile=~/([0-9]+)/i;
	$datversion=$1;
	
#	print "Current Dat: $version  Available Dat: $datversion  Datfile: $datfile\n";
	$download=$serverurl . $daturl;
	if ($datversion>$version) {
		$date=`date`;
		chomp($date);
		`mkdir -p /private/tmp/dat; cd /private/tmp/dat; curl -s -O "$download"; tar xf $datfile; cp -f *dat $virexdir; rm -rf /private/tmp/dat`;
		open EMAIL, "| mail -s 'DAT Update ($datversion)' -f $frommail $mail";
		print EMAIL "DAT Update: $date\nThe Virex DAT file on $hostn has been upgraded from v$version to v$datversion.\n";
		close (EMAIL);
	}
}

